<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Processor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">Processor.java</span></div><h1>Processor.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.configuration.Configuration;
import io.gitlab.littlesaints.protean.configuration.ProcessorOptions;
import io.gitlab.littlesaints.protean.event.State;
import io.gitlab.littlesaints.protean.resources.ResourceLocator;
import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NonNull;
import lombok.extern.log4j.Log4j2;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;
import java.util.function.BiFunction;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;

<span class="pc bpc" id="L42" title="2 of 4 branches missed.">@AllArgsConstructor(access = AccessLevel.PRIVATE)</span>
<span class="fc" id="L43">@Log4j2</span>
public class Processor&lt;E&gt; {

<span class="fc" id="L46">    @Getter</span>
    @NonNull
    private final Function&lt;E, State&gt; function;

    @NonNull
    private final Runnable onClose;

    public static &lt;E&gt; Processor&lt;E&gt; of(Function&lt;E, State&gt; function, Runnable onClose) {
<span class="fc" id="L54">        return new Processor &lt;&gt;(function, onClose);</span>
    }

    public static &lt;E, T&gt; Supplier&lt;Processor&lt;E&gt;&gt; supplier(Configuration configuration, ResourceLocator locator, ProcessorOptions options) {

<span class="fc" id="L59">        final Map&lt;String, Function&lt;?, ?&gt;&gt; endpoints = evaluateEndpoints(configuration, options);</span>
<span class="fc" id="L60">        final Config config = evaluateConfiguration(options);</span>

<span class="fc" id="L62">        final Optional &lt;Supplier &lt;T&gt;&gt; toolsSupplierOp = locator.optionalLookupOrThrow(options.getTools(), &quot;tools&quot;);</span>
<span class="pc bpc" id="L63" title="1 of 2 branches missed.">        if (toolsSupplierOp.isPresent()) {</span>

<span class="nc" id="L65">            final Optional &lt;Consumer &lt;T&gt;&gt; onCloseOp = locator.optionalLookupOrThrow(options.getOnClose(), &quot;onClose&quot;);</span>

            final BiFunction&lt;E, T, State&gt; function;
<span class="nc bnc" id="L68" title="All 2 branches missed.">            if (config == null) {</span>
<span class="nc bnc" id="L69" title="All 2 branches missed.">                if (endpoints == null) {</span>
<span class="nc" id="L70">                    final Supplier&lt;BiFunction&lt;E, T, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L71">                    function = supplier.get();</span>
<span class="nc" id="L72">                } else {</span>
<span class="nc" id="L73">                    final Function&lt;Map&lt;String, Function&lt;?, ?&gt;&gt;, BiFunction&lt;E, T, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L74">                    function = supplier.apply(endpoints);</span>
<span class="nc" id="L75">                }</span>
            } else {
<span class="nc bnc" id="L77" title="All 2 branches missed.">                if (endpoints == null) {</span>
<span class="nc" id="L78">                    final Function&lt;Config, BiFunction&lt;E, T, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L79">                    function = supplier.apply(config);</span>
<span class="nc" id="L80">                } else {</span>
<span class="nc" id="L81">                    final BiFunction&lt;Config, Map&lt;String, Function&lt;?, ?&gt;&gt;, BiFunction&lt;E, T, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L82">                    function = supplier.apply(config, endpoints);</span>
                }
            }

<span class="nc" id="L86">            final Supplier &lt;T&gt; toolsSupplier = toolsSupplierOp.get();</span>
<span class="nc bnc" id="L87" title="All 2 branches missed.">            if (onCloseOp.isPresent()) {</span>
<span class="nc" id="L88">                final Consumer &lt;T&gt; onClose = onCloseOp.get();</span>
<span class="nc" id="L89">                return () -&gt; {</span>
<span class="nc" id="L90">                    final T tools = toolsSupplier.get();</span>
<span class="nc" id="L91">                    return Processor.of(e -&gt; function.apply(e, tools), () -&gt; onClose.accept(tools));</span>
                };
            } else {
<span class="nc" id="L94">                return () -&gt; {</span>
<span class="nc" id="L95">                    final T tools = toolsSupplier.get();</span>
<span class="nc" id="L96">                    return Processor.of(e -&gt; function.apply(e, tools), () -&gt; {});</span>
                };
            }

        } else {

<span class="fc" id="L102">            final Optional &lt;Runnable&gt; onCloseOp = locator.optionalLookupOrThrow(options.getOnClose(), &quot;onClose&quot;);</span>

            final Function&lt;E, State&gt; function;
<span class="pc bpc" id="L105" title="1 of 2 branches missed.">            if (config == null) {</span>
<span class="nc bnc" id="L106" title="All 2 branches missed.">                if (endpoints == null) {</span>
<span class="nc" id="L107">                    final Supplier&lt;Function&lt;E, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L108">                    function = supplier.get();</span>
<span class="nc" id="L109">                } else {</span>
<span class="nc" id="L110">                    final Function&lt;Map&lt;String, Function&lt;?, ?&gt;&gt;, Function&lt;E, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="nc" id="L111">                    function = supplier.apply(endpoints);</span>
<span class="nc" id="L112">                }</span>
            } else {
<span class="fc bfc" id="L114" title="All 2 branches covered.">                if (endpoints == null) {</span>
<span class="fc" id="L115">                    final Function&lt;Config, Function&lt;E, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="fc" id="L116">                    function = supplier.apply(config);</span>
<span class="fc" id="L117">                } else {</span>
<span class="fc" id="L118">                    final BiFunction&lt;Config, Map&lt;String, Function&lt;?, ?&gt;&gt;, Function&lt;E, State&gt;&gt; supplier = locator.lookupOrThrow(options.getSupplier(), &quot;Resource&quot;);</span>
<span class="fc" id="L119">                    function = supplier.apply(config, endpoints);</span>
                }
            }

<span class="pc bpc" id="L123" title="1 of 2 branches missed.">            if (onCloseOp.isPresent()) {</span>
<span class="nc" id="L124">                final Runnable onClose = onCloseOp.get();</span>
<span class="nc" id="L125">                return () -&gt; Processor.of(function, onClose);</span>
            } else {
<span class="fc" id="L127">                return () -&gt; Processor.of(function, () -&gt; {});</span>
            }
        }
    }

    private static Config evaluateConfiguration(ProcessorOptions options) {
        final Config config;
<span class="pc bpc" id="L134" title="1 of 2 branches missed.">        if (options.getConfig().isEmpty()) {</span>
<span class="nc" id="L135">            config = null;</span>
        } else {
<span class="fc" id="L137">            config = new Config(options.getConfig());</span>
        }
<span class="fc" id="L139">        return config;</span>
    }

    private static Map&lt;String, Function&lt;?, ?&gt;&gt; evaluateEndpoints(Configuration configuration, ProcessorOptions options) {
        final Map&lt;String, Function&lt;?, ?&gt;&gt; endpoints;
<span class="fc bfc" id="L144" title="All 2 branches covered.">        if (options.getContexts().isEmpty()) {</span>
<span class="fc" id="L145">            endpoints = null;</span>
        } else {
<span class="fc" id="L147">            endpoints = new HashMap&lt;&gt;();</span>
<span class="fc" id="L148">            options.getContexts().forEach(s -&gt; {</span>
<span class="pc bpc" id="L149" title="1 of 2 branches missed.">                if (configuration.getContext(s).isPresent()) {</span>
<span class="fc" id="L150">                    endpoints.put(s, configuration.getContext(s).get().getEndpoint());</span>
                } else {
<span class="nc" id="L152">                    log.error(&quot;Referenced context {} not found !!&quot;, s);</span>
                }
<span class="fc" id="L154">            });</span>
        }
<span class="fc" id="L156">        return endpoints;</span>
    }

    public static &lt;E&gt; Supplier&lt;Processor&lt;E&gt;&gt; compose(Supplier&lt;Processor&lt;E&gt;&gt; thisSupplier, Supplier&lt;Processor&lt;E&gt;&gt; thatSupplier) {
<span class="fc" id="L160">        return () -&gt; {</span>
<span class="fc" id="L161">            Processor&lt;E&gt; thisProcessor = thisSupplier.get();</span>
<span class="fc" id="L162">            Processor&lt;E&gt; thatProcessor = thatSupplier.get();</span>
<span class="fc" id="L163">            Function&lt;E, State&gt; compositeFx = e -&gt; {</span>
                State state;
<span class="pc bpc" id="L165" title="1 of 2 branches missed.">                if ((state = thisProcessor.function.apply(e)) == State.SUCCESS) {</span>
<span class="fc" id="L166">                    return thatProcessor.function.apply(e);</span>
                } else {
<span class="nc" id="L168">                    return state;</span>
                }
            };
<span class="fc" id="L171">            Runnable compositeOnClose = () -&gt; {</span>
<span class="nc" id="L172">                thisProcessor.close();</span>
<span class="nc" id="L173">                thatProcessor.close();</span>
<span class="nc" id="L174">            };</span>
<span class="fc" id="L175">            return new Processor&lt;&gt;(compositeFx, compositeOnClose);</span>
        };
    }

    public void close() {
<span class="fc" id="L180">        onClose.run();</span>
<span class="fc" id="L181">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>